/* optab.h */

op opcodes [] = {
/* 0 */   {"BRSET0", 3, DIR_REL, 5}, {"BRCLR0", 3, DIR_REL, 5}, {"BRSET1", 3, DIR_REL, 5}, {"BRCLR1", 3, DIR_REL, 5},
      {"BRSET2", 3, DIR_REL, 5}, {"BRCLR2", 3, DIR_REL, 5}, {"BRSET3", 3, DIR_REL, 5}, {"BRCLR3", 3, DIR_REL, 5},
      {"BRSET4", 3, DIR_REL, 5}, {"BRCLR4", 3, DIR_REL, 5}, {"BRSET5", 3, DIR_REL, 5}, {"BRCLR5", 3, DIR_REL, 5},
      {"BRSET6", 3, DIR_REL, 5}, {"BRCLR6", 3, DIR_REL, 5}, {"BRSET7", 3, DIR_REL, 5}, {"BRCLR7", 3, DIR_REL, 5},
/* 1 */   {"BSET0", 2, DIR8, 4}, {"BCLR0", 2, DIR8, 4}, {"BSET1", 2, DIR8, 4}, {"BCLR1", 2, DIR8, 4},
      {"BSET2", 2, DIR8, 4}, {"BCLR2", 2, DIR8, 4}, {"BSET3", 2, DIR8, 4}, {"BCLR3", 2, DIR8, 4},
      {"BSET4", 2, DIR8, 4}, {"BCLR4", 2, DIR8, 4}, {"BSET5", 2, DIR8, 4}, {"BCLR5", 2, DIR8, 4},
      {"BSET6", 2, DIR8, 4}, {"BCLR6", 2, DIR8, 4}, {"BSET7", 2, DIR8, 4}, {"BCLR7", 2, DIR8, 4},
/* 2 */   {"BRA", 2, REL, 3}, {"BRN", 2, REL, 3}, {"BHI", 2, REL, 3}, {"BLS", 2, REL, 3},
      {"BCC", 2, REL, 3}, {"BCS", 2, REL, 3}, {"BNE", 2, REL, 3}, {"BEQ", 2, REL, 3},
      {"BHCC", 2, REL, 3}, {"BHCS", 2, REL, 3}, {"BPL", 2, REL, 3}, {"BMI", 2, REL, 3},
      {"BMC", 2, REL, 3}, {"BMS", 2, REL, 3}, {"BIL", 2, REL, 3}, {"BIH", 2, REL, 3},
/* 3 */   {"NEG", 2, DIR8, 4}, {"CBEQ", 3, DIR8, 5}, {"", 1, INH, 1}, {"COM", 2, DIR8, 4},
      {"LSR", 2, DIR8, 4}, {"STHX", 2, DIR8, 4}, {"ROR", 2, DIR8, 4}, {"ASR", 2, DIR8, 4},
      {"LSL", 2, DIR8, 4}, {"ROL", 2, DIR8, 4}, {"DEC", 2, DIR8, 4}, {"DBNZ", 3, DIR_REL, 5},
      {"INC", 2, DIR8, 4}, {"TST", 2, DIR8, 3}, {"", 1, INH, 1}, {"CLR", 2, DIR8, 3},
/* 4 */   {"NEGA", 1, INH, 1}, {"CBEQA", 3, IMM_REL, 4}, {"MUL", 1, INH, 5}, {"COMA", 1, INH, 1},
      {"LSRA", 1, INH, 1}, {"LDHX", 3, IMM16, 3}, {"RORA", 1, INH, 1}, {"ASRA", 1, INH, 1},
      {"LSLA", 1, INH, 1}, {"ROLA", 1, INH, 1}, {"DECA", 1, INH, 1}, {"DBNZA", 2, INH, 3},
      {"INCA", 1, INH, 1}, {"TSTA", 1, INH, 1}, {"MOV", 3, DD, 5}, {"CLRA", 1, INH, 1},
/* 5 */   {"NEGX", 1, INH, 1}, {"CBEQX", 3, IMM_REL, 4}, {"DIV", 1, INH, 7}, {"COMX", 1, INH, 1},
      {"LSRX", 1, INH, 1}, {"LDHX", 2, DIR8, 4}, {"RORX", 1, INH, 1}, {"ASRX", 1, INH, 1},
      {"LSLX", 1, INH, 1}, {"ROLX", 1, INH, 1}, {"DECX", 1, INH, 1}, {"DBNZX", 2, INH, 3},
      {"INCX", 1, INH, 1}, {"TSTX", 1, INH, 1}, {"MOV", 2, DIX_P, 4}, {"CLRX", 1, INH, 1},
/* 6 */   {"NEG", 2, IX1, 4}, {"CBEQ", 3, IX1_P_REL, 5}, {"NSA", 1, INH, 3}, {"COM", 2, IX1, 4},
      {"LSR", 2, IX1, 4}, {"CPHX", 3, IMM16, 3}, {"ROR", 2, IX1, 4}, {"ASR", 2, IX1, 4},
      {"LSL", 2, IX1, 4}, {"ROL", 2, IX1, 4}, {"DEC", 2, IX1, 4}, {"DBNZ", 3, IX1, 5},
      {"INC", 2, IX1, 4}, {"TST", 2, IX1, 3}, {"MOV", 3, IMD, 4}, {"CLR", 2, IX1, 3},
/* 7 */   {"NEG", 1, IX, 3}, {"CBEQ", 2, IX_P_REL, 4}, {"DAA", 1, INH, 2}, {"COM", 1, IX, 3},
      {"LSR", 1, IX, 3}, {"CPHX", 2, DIR8, 4}, {"ROR", 1, IX, 3}, {"ASR", 1, IX, 3},
      {"LSL", 1, IX, 3}, {"ROL", 1, IX, 3}, {"DEC", 1, IX, 3}, {"DBNZ", 2, IX, 4},
      {"INC", 1, IX, 3}, {"TST", 1, IX, 2}, {"MOV", 2, IX_P_D, 4}, {"CLR", 1, IX, 2},
/* 8 */   {"RTI", 1, INH, 7}, {"RTS", 1, INH, 4}, {"", 1, INH, 1}, {"SWI", 1, INH, 9},
      {"TAP", 1, INH, 2}, {"TPA", 1, INH, 1}, {"PULA", 1, INH, 2}, {"PSHA", 1, INH, 2},
      {"PULX", 1, INH, 2}, {"PSHX", 1, INH, 2}, {"PULH", 1, INH, 2}, {"PSHH", 1, INH, 2},
      {"CLRH", 1, INH, 1}, {"", 1, INH, 1}, {"STOP", 1, INH, 1}, {"WAIT", 1, INH, 1},
/* 9 */   {"BGE", 2, REL, 3}, {"BLT", 2, REL, 3}, {"BGT", 2, REL, 3}, {"BLE", 2, REL, 3},
      {"TXS", 1, INH, 3}, {"TSX", 1, INH, 3}, {"", 1, INH, 1}, {"TAX", 1, INH, 1},
      {"CLC", 1, INH, 1}, {"SEC", 1, INH, 1}, {"CLI", 1, INH, 2}, {"SEI", 1, INH, 2},
      {"RSP", 1, INH, 1}, {"NOP", 1, INH, 1}, {"", 1, INH, 1}, {"TXA", 1, INH, 1},
/* A */   {"SUB", 2, IMM, 2}, {"CMP", 2, IMM, 2}, {"SBC", 2, IMM, 2}, {"CPX", 2, IMM, 2},
      {"AND", 2, IMM, 2}, {"BIT", 2, IMM, 2}, {"LDA", 2, IMM, 2}, {"AIS", 2, IMM, 2},
      {"EOR", 2, IMM, 2}, {"ADC", 2, IMM, 2}, {"ORA", 2, IMM, 2}, {"ADD", 2, IMM, 2},
      {"", 1, INH, 1}, {"BSR", 2, REL, 4}, {"LDX", 2, IMM, 2}, {"AIX", 2, IMM, 2},
/* B */   {"SUB", 2, DIR8, 3}, {"CMP", 2, DIR8, 3}, {"SBC", 2, DIR8, 3}, {"CPX", 2, DIR8, 3},
      {"AND", 2, DIR8, 3}, {"BIT", 2, DIR8, 3}, {"LDA", 2, DIR8, 3}, {"STA", 2, DIR8, 3},
      {"EOR", 2, DIR8, 3}, {"ADC", 2, DIR8, 3}, {"ORA", 2, DIR8, 3}, {"ADD", 2, DIR8, 3},
      {"JMP", 2, DIR8, 2}, {"JSR", 2, DIR8, 4}, {"LDX", 2, DIR8, 3}, {"STX", 2, DIR8, 3},
/* C */   {"SUB", 3, EXT, 4}, {"CMP", 3, EXT, 4}, {"SBC", 3, EXT, 4}, {"CPX", 3, EXT, 4},
      {"AND", 3, EXT, 4}, {"BIT", 3, EXT, 4}, {"LDA", 3, EXT, 4}, {"STA", 3, EXT, 4},
      {"EOR", 3, EXT, 4}, {"ADC", 3, EXT, 4}, {"ORA", 3, EXT, 4}, {"ADD", 3, EXT, 4},
      {"JMP", 3, JEXT, 3}, {"JSR", 3, JEXT, 5}, {"LDX", 3, EXT, 4}, {"STX", 3, EXT, 4},
/* D */   {"SUB", 3, IX2, 4}, {"CMP", 3, IX2, 4}, {"SBC", 3, IX2, 4}, {"CPX", 3, IX2, 4},
      {"AND", 3, IX2, 4}, {"BIT", 3, IX2, 4}, {"LDA", 3, IX2, 4}, {"STA", 3, IX2, 4},
      {"EOR", 3, IX2, 4}, {"ADC", 3, IX2, 4}, {"ORA", 3, IX2, 4}, {"ADD", 3, IX2, 4},
      {"JMP", 3, IX2, 4}, {"JSR", 3, IX2, 6}, {"LDX", 3, IX2, 4}, {"STX", 3, IX2, 4},
/* E */   {"SUB", 2, IX1, 3}, {"CMP", 2, IX1, 3}, {"SBC", 2, IX1, 3}, {"CPX", 2, IX1, 3},
      {"AND", 2, IX1, 3}, {"BIT", 2, IX1, 3}, {"LDA", 2, IX1, 3}, {"STA", 2, IX1, 3},
      {"EOR", 2, IX1, 3}, {"ADC", 2, IX1, 3}, {"ORA", 2, IX1, 3}, {"ADD", 2, IX1, 3},
      {"JMP", 2, IX1, 3}, {"JSR", 2, IX1, 5}, {"LDX", 2, IX1, 3}, {"STX", 2, IX1, 3},
/* F */   {"SUB", 1, IX, 2}, {"CMP", 1, IX, 2}, {"SBC", 1, IX, 2}, {"CPX", 1, IX, 2},
      {"AND", 1, IX, 2}, {"BIT", 1, IX, 2}, {"LDA", 1, IX, 2}, {"STA", 1, IX, 2},
      {"EOR", 1, IX, 2}, {"ADC", 1, IX, 2}, {"ORA", 1, IX, 2}, {"ADD", 1, IX, 2},
      {"JMP", 1, IX, 2}, {"JSR", 1, IX, 4}, {"LDX", 1, IX, 2}, {"STX", 1, IX, 2}
};

op opcodes9E6 [] = {
/* 9E6 */ {"NEG", 3, SP1, 5}, {"CBEQ", 4, SP1_REL, 6}, {"", 1, INH, 1}, {"COM", 3, SP1, 5},
      {"LSR", 3, SP1, 5}, {"", 1, INH, 5}, {"ROR", 3, SP1, 5}, {"ASR", 3, SP1, 5},
      {"LSL", 3, SP1, 5}, {"ROL", 3, SP1, 5}, {"DEC", 3, SP1, 5}, {"DBNZ", 4, SP1_REL, 6},
      {"INC", 3, SP1, 5}, {"TST", 3, SP1, 4}, {"", 1, INH, 1}, {"CLR", 3, SP1, 4},
};

op opcodes9ED [] = {
/* 9ED */ {"SUB", 4, SP2, 5}, {"CMP", 4, SP2, 5}, {"SBC", 4, SP2, 5}, {"CPX", 4, SP2, 5},
      {"AND", 4, SP2, 5}, {"BIT", 4, SP2, 5}, {"LDA", 4, SP2, 5}, {"STA", 4, SP2, 5},
      {"EOR", 4, SP2, 5}, {"ADC", 4, SP2, 5}, {"ORA", 4, SP2, 5}, {"ADD", 4, SP2, 5},
      {"", 1, INH, 1}, {"", 1, INH, 1}, {"LDX", 4, SP2, 5}, {"STX", 4, SP2, 5},
};

op opcodes9EE [] = {
/* 9EE */ {"SUB", 3, SP1, 4}, {"CMP", 3, SP1, 4}, {"SBC", 3, SP1, 4}, {"CPX", 3, SP1, 4},
      {"AND", 3, SP1, 4}, {"BIT", 3, SP1, 4}, {"LDA", 3, SP1, 4}, {"STA", 3, SP1, 4},
      {"EOR", 3, SP1, 4}, {"ADC", 3, SP1, 4}, {"ORA", 3, SP1, 4}, {"ADD", 3, SP1, 4},
      {"", 1, INH, 1}, {"", 1, INH, 1}, {"LDX", 3, SP1, 4}, {"STX", 3, SP1, 4},
};
